=head1 NAME

PerlReplaceBox.pl - replace-box for text editors

=head1 SYNOPSIS

perl PerlReplaceBox.pl [ operator [ pattern [ replacement [ options ] ] ] ]

=head1 DESCRIPTION

uuvEBhE\AʂWo͂ɕԂB

ij
uZqv "s"AuuOv "aaa"A
uuv "bbb"AuIvVv "g"
̏ꍇA"s/aaa/bbb/g" Ƃo͂B

p[^w肵ꍇAe Entry ̃ftHglƂĎgpB

o͂ ShiftJISicp932jōsB

LZ͉o͂ȂB

=cut

use strict;

use encoding 'cp932';
binmode(STDERR, 'raw: encoding(cp932)');

use Encode;

use Tk;

# e Entry  textvariable
my $operator	= shift @ARGV || 's';	# Zq
my $pattern		= shift @ARGV;			# uO
my $replacement	= shift @ARGV;			# u
my $options		= shift @ARGV || 'g';	# IvV

#-------------------
# Widget ̏
#-------------------

my $mw = MainWindow->new();

# uZqvxGg[
my $l0 = $mw->Label( -text => 'Zq' );
my $e0 = $mw->Entry(
	-textvariable => \$operator,
	-width	=> '2'
);
my $l0b = $mw->Label( -text => '("s" or "tr" / "y")' );

# uuOvxGg[
my $l1 = $mw->Label( -text => 'uO' );
my $e1 = $mw->Entry( -textvariable => \$pattern );

# uuvxGg[
my $l2 = $mw->Label( -text => 'u' );
my $e2 = $mw->Entry( -textvariable => \$replacement );

# uIvVvxGg[
my $l3 = $mw->Label( -text => 'IvV' );
my $e3 = $mw->Entry(
	-textvariable => \$options,
	-width	=> '10'				# e d˂l̂߂ɁA]
);
my $l3b = $mw->Label( -text => '("egimosx" or "cds")' );

# uuv{^
my $b0 = $mw->Button(
	-text => 'u',
	-command => \&replace
);

# uLZv{^
my $b1 = $mw->Button(
	-text => 'LZ',
	-command => \&cancel
);


#-------------------
# Widget ̔zu
#-------------------

# grid ݒp̃e[uBwidget, columnspan, sticky ̏ŎwB
my @grid = (
	[
		[ $l0, 1, 'news' ],
		[ $e0, 1, 'nws' ],
		[ $l0b, 1, 'news' ],
	],
	[
		[ $l1, 1, 'news' ],
		[ $e1, 2, 'news' ],
	],
	[
		[ $l2, 1, 'news' ],
		[ $e2, 2, 'news' ],
	],
	[
		[ $l3, 1, 'news' ],
		[ $e3, 1, 'nws' ],
		[ $l3b, 1, 'news' ],
	],
	[
		undef,
		[ $b0, 1, '' ],
		[ $b1, 1, '' ],
	],
);	

# grid() ̎s
for (my $i = 0; $i < @grid; $i++) {
	my $cells = $grid[$i];
	
	for (my $j = 0; $j < @$cells; $j++) {
		my $cell = $cells->[$j];
		next unless defined $cell;
		
		my $widget = $cell->[0];
		my $colspan = $cell->[1];
		my $sticky = $cell->[2];
		
		$widget->grid(
			-row		=> $i,
			-column		=> $j,
			-columnspan	=> $colspan,
			-sticky		=> $sticky
		);
	}
}
	
# Obh̕w
$mw->gridRowconfigure(4, -weight => 1);
$mw->gridColumnconfigure(3, -weight => 1);


#-------------------
# ̑̋ݒ
#-------------------

# V[gJbg̐ݒ
foreach my $entry ($e0, $e1, $e2, $e3) {
	$entry->bind("<Return>", \&replace);
	$entry->bind("<Escape>", \&cancel);
}

# tH[JXw
$e1->focus;

# EBhE`
MainLoop();

=head1 FUNCTIONS

=cut

=head2 replace()

uuv{^ior Enterj̏

=cut

sub replace
{
	print "$operator/$pattern/$replacement/$options";

	exit(0);
}

=head2 cancel()

uLZv{^ior ESCj̏

=cut

sub cancel
{
	exit(0);
}
